SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-Models'!
SystemOrganization addCategory: #'Xpf-Client-ProjectTalk'!

SimpleHierarchicalListMorph subclass: #XpfIterationTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationTreeMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:53'!
for: anXpfIteration

	| result |
	result := self
		on: (XpfIterationTreeModel new iteration: anXpfIteration)
		list: #rootItems
		selected: nil
		changeSelected: nil
		menu: nil
		keystroke: nil.
	^ result model addDependent: result expandRoots
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:06'!
backupExpandedState

	| backup |
	backup := Dictionary new.
	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			backup at: m complexContents model restUri put: m isExpanded]].
	^ backup.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:49'!
collapseAll
	"Expand all of the roots!!"
	
	self roots do: [:m |
		self collapseAll: m].
	self adjustSubmorphPositions! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
collapseAll: aMorph
	| allChildren |
	aMorph isExpanded ifTrue: [aMorph toggleExpandedState].
	allChildren _ OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded])
			ifTrue: [self collapseAll: each]].
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:12'!
indentingItemClass

	^ XpfIndentingListItemMorph! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 10:27'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:52'!
restoreExpandedState: aDictionary

	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			(aDictionary includesKey: m complexContents model restUri)
				ifTrue: [
					m isExpanded = (aDictionary at: m complexContents model restUri) ifFalse: [m toggleExpandedState]]]].! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 17:12'!
update: aSymbol

	aSymbol = #userStories ifTrue: [ | backup |
		backup := self backupExpandedState.
		self
			list: self getList;
			collapseAll;
			expandRoots;
			restoreExpandedState: backup;
			adjustSubmorphPositions].
	super update: aSymbol.! !

PasteUpMorph subclass: #XpfUserStoryPoolMorph
	instanceVariableNames: 'userStoryAddMorph deleteMorph titleMorph scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryPoolMorph commentStamp: 'mt 10/26/2009 13:28' prior: 0!
Also known as: iteration morph!

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mig 4/17/2009 18:10'!
defaultGridSize

	^ 20@20! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'SR 4/12/2009 21:52'!
defaultMaxTime

	^ 50! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mt 3/31/2009 15:39'!
for: anXpfIteration

	^ self new model: anXpfIteration! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:51'!
acceptDroppingMorph: aUserStoryMorph event: evt 

	aUserStoryMorph hasNewUserStory 
		ifTrue: [ self acceptNewUserStory: aUserStoryMorph ]
		ifFalse: [
			(self acceptExistentUserStory: aUserStoryMorph)
				ifTrue: [super acceptDroppingMorph: aUserStoryMorph event: evt]]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mig 7/23/2009 15:22'!
acceptExistentUserStory: aUserStoryMorph 

	(self isDuplicateMorph: aUserStoryMorph)
		ifTrue: [ aUserStoryMorph delete. ^ self ].
	aUserStoryMorph position: (self gridPoint: aUserStoryMorph position).
	self positionUserStory: aUserStoryMorph model droppedMorph: aUserStoryMorph.
	(self includesUserStory: aUserStoryMorph model)
		ifTrue: [ self moveToNewIteration: aUserStoryMorph. ^ false]
		ifFalse: [^ true]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mig 7/23/2009 15:17'!
acceptNewUserStory: anUserStoryMorph 

	| userStory |
	userStory := self model addNewUserStory: XpfUserStoryAddMorph emptyUserStory.
	
	userStory ifNil: [
		anUserStoryMorph delete.
		^ self].
	
	self positionUserStory: userStory droppedMorph: anUserStoryMorph.
	anUserStoryMorph delete.! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'cs 3/10/2009 16:14'!
acceptsUserStories

	^ true! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/10/2009 09:50'!
addNewUserStoryToIteration

	| userStoryData |
	userStoryData := Dictionary newFrom: 
		{'title' -> 'Please enter content for new user story'}.
	^ self model addNewUserStory: userStoryData! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/28/2009 11:14'!
addUserStorySubmorph: userStory

	^ self addMorph: (XpfUserStoryMorph forUserStory: userStory)! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:08'!
adjustLayoutBounds
	"Adjust the receivers bounds depending on the resizing strategy imposed"
	| hFit vFit box myExtent extent |
	
	hFit := self hResizing.
	vFit := self vResizing.
	
	(hFit = #rigid and: [vFit = #rigid]) ifTrue: [^self].
	
	box := self layoutBounds.
	myExtent := box extent.
	extent := self submorphBounds corner - box origin.
	
	hFit = #growWrap ifTrue: [
		(extent x > owner owner bounds width)
			ifFalse: [hFit := #spaceFill]
			ifTrue: [hFit := #shrinkWrap]].
	
	vFit = #growWrap ifTrue: [
		(extent y > owner owner bounds height)
			ifFalse: [vFit := #spaceFill]
			ifTrue: [vFit := #shrinkWrap]].
		
	hFit == #shrinkWrap ifTrue:[myExtent := extent x @ myExtent y].
	hFit == #spaceFill ifTrue: [myExtent := owner owner bounds width @ myExtent y].
	
	vFit == #shrinkWrap ifTrue:[myExtent := myExtent x @ extent y].
	vFit == #spaceFill ifTrue: [myExtent := myExtent x @ owner owner bounds height].
	
	"Make sure we don't get smaller than minWidth/minHeight"
	myExtent x < self minWidth ifTrue:[
		myExtent := (myExtent x max: 
			(self minWidth - self bounds width + self layoutBounds width)) @ myExtent y].
	myExtent y < self minHeight ifTrue:[
		myExtent := myExtent x @ (myExtent y max:
			(self minHeight - self bounds height + self layoutBounds height))].
	self layoutBounds: (box origin extent: myExtent).! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustLeft: aMorph

	^ 0 max: ((aMorph left - self left) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustTop: aMorph

	^ 0 max: ((aMorph top - self top) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/28/2009 11:15'!
buildUserStorySubmorphs

	self model ifNotNil: [
		self model userStories do: [ :userStory| 
			self addUserStorySubmorph: userStory]].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:41'!
deleteMorph

	^ deleteMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 18:07'!
deleteMorph: aMorph

	deleteMorph := aMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'mig 7/23/2009 15:16'!
doubleClick: anEvent

	| userStory |
	userStory := self addNewUserStoryToIteration.
	userStory ifNil: [^self].
	self positionUserStory: userStory to: anEvent cursorPoint.! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:59'!
generateProgress: value with: aCharacter

	value < 0 ifTrue: [''].
	^ (String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 22:00'!
generateProgress: value with: aCharacter negWith: aNegCharacter

	^ value < 0
		ifTrue: [(String new: ((10 * (value negated)) / self class defaultMaxTime) ceiling) collect: [:e | aNegCharacter]]
		ifFalse: [(String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]].! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'mfp 4/29/2009 17:36'!
includesUserStory: userStory

	^ self model userStories noneSatisfy: [ :myStory | myStory id = userStory id ]! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'bs 7/8/2009 22:51'!
initialize

	super initialize.

	self
		borderWidth: 0;
		fillStyle: Color veryVeryLightGray;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		enableDragNDrop;
		gridModulus: self class defaultGridSize;
		griddingOnOff;
		addMorph: self titleMorph.
		
	self addMorphBack: (XpfEstimationCircleMorph nUnits: 60 segmentUnitsComputing: [
		(self submorphs select: [:m | m class = XpfUserStoryMorph]) inject: 0 into: [:sum :storyMorph | sum + storyMorph timeEstimated]]).! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'mfp 4/29/2009 17:29'!
isDuplicateMorph: aUserStoryMorph

	aUserStoryMorph formerOwner ifNotNilDo: [ :o | 
		(o submorphs anySatisfy: [ :s | s model = aUserStoryMorph model ])
		ifTrue: [ ^ true ]].
	^ false! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:51'!
model

	^ model! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:50'!
model: aXpfIteration

	self model ifNotNil: [
		self model removeDependent: self.
		self model userStories removeDependent: self].

	model := aXpfIteration.
		
	self model ifNotNil: [
		self
			removeAllMorphsIn: self userStorySubmorphs;
			buildUserStorySubmorphs;
			updateTitle.
		
		self model addDependent: self.
		self model userStories addDependent: self].
! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/9/2009 18:15'!
mouseDown: evt
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. #doubleClick:. nil. nil}
		threshold: 5.! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mig 7/23/2009 15:24'!
moveToNewIteration: aUserStoryMorph 

	| result |
	result := self model addUserStory: aUserStoryMorph model.
	aUserStoryMorph delete.
	
	result ifNil: [[self model repository reload] forkAndWait]! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mig 7/23/2009 13:30'!
positionUserStory: userStory droppedMorph: aMorph

	userStory deferCommit: [
		userStory
			positionX: (self adjustLeft: aMorph);
			positionY: (self adjustTop: aMorph)].! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mig 7/23/2009 13:30'!
positionUserStory: userStory to: aPoint

	userStory deferCommit: [
		userStory
			positionX: (aPoint x * 10000);
			positionY: (aPoint y * 10000)].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane

	^ scrollPane! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane: anObject

	scrollPane := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 4/29/2009 13:51'!
titleMorph

	titleMorph ifNil: [
		self titleMorph: '' asText asMorph.
		self titleMorph 
			beAllFont: (XpfClient sansFontAt: 18);
			color: Color darkGray;
			lock].
	^ titleMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:19'!
titleMorph: anObject

	titleMorph := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/10/2009 12:04'!
toggleShow

	self scrollPane isNil
		ifTrue: [self
			visible: self visible not;
			disableTableLayout: self visible not]
		ifFalse: [self scrollPane toggleShow].! !

!XpfUserStoryPoolMorph methodsFor: 'updating' stamp: 'mfp 4/29/2009 18:05'!
update: aSymbol

	aSymbol = #title ifTrue: [self updateTitle].
	aSymbol = #timeIdeal ifTrue: [self updateTitle].
	aSymbol = #userStories ifTrue: [self updateTitle].
	aSymbol = #userStoriesLoaded ifTrue: [
		self
			updateTitle;
			updateUserStoryMorphs].
	
	super update: aSymbol.! !

!XpfUserStoryPoolMorph methodsFor: 'updating' stamp: 'mt 10/26/2009 13:33'!
updateTitle
	"Compute and set the contents of the iteration title."

	| iterationTitle idealTime userStoriesTimeActual userStoriesTimeEstimated timeEstimated timeActual |
	iterationTitle := self model title.
	(self model timeIdeal isNil or: [self model isXpfFutureIteration]) ifTrue:
		[self titleMorph contents: ' ', iterationTitle.
		^self].
	idealTime := '(',self model timeIdeal asString,')'.
	
	userStoriesTimeActual := 0.
	userStoriesTimeEstimated := 0.
	self model userStories do: [:us |
		us timeActual ifNotNil: [userStoriesTimeActual := userStoriesTimeActual + us timeActual].
		us timeEstimated ifNotNil: [userStoriesTimeEstimated := userStoriesTimeEstimated + us timeEstimated]].
	
	timeEstimated := (self generateProgress: userStoriesTimeEstimated  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeEstimated) with: $- negWith: $#).
	timeActual := (self generateProgress: userStoriesTimeActual  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeActual) with: $- negWith: $#).
	
	self titleMorph contents: iterationTitle, idealTime, Character cr asString,timeEstimated, Character cr asString, timeActual.! !

!XpfUserStoryPoolMorph methodsFor: 'updating' stamp: 'mt 10/26/2009 13:40'!
updateUserStoryMorphs
	"Aggregate all stories that belong to this iteration and add missing morphs."

	| oldUserStories morphsAtHand |

	morphsAtHand := World hands 
		inject: OrderedCollection new 
		into: [:morphs :hand | 
			morphs, (hand submorphs select: [:m | m isUserStoryMorph and: [m model iteration = self model]])].
	
	oldUserStories := Dictionary newFrom:
		(self userStorySubmorphs, morphsAtHand
			collect: [:morph | morph model -> morph]).
	oldUserStories keys reject: [:story | self model userStories includes: story]
		thenDo: [:story | (oldUserStories at: story) delete].
	self model userStories reject: [:story | oldUserStories keys includes: story]
		thenDo: [:story | self addUserStorySubmorph: story].
! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:34'!
userStoryAddMorph

	^ userStoryAddMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:42'!
userStoryAddMorph: anObject

	userStoryAddMorph := anObject.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/2/2009 15:23'!
userStorySubmorphs

	^ self submorphs select: [:aMorph| aMorph isUserStoryMorph]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:38'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mfp 4/29/2009 14:34'!
withScrollBars

	self scrollPane ifNil: [
		self scrollPane: XpfScrollPane new.
		(self scrollPane)
			scroller addMorph: self;
			maxCellSize: 1040 @ 1450;
			borderWidth: 0.
		self extent: 960 @ 1400;
			vResizing: #rigid;
			hResizing: #rigid].
	^ self scrollPane! !

ImageMorph subclass: #XpfDeleteMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfDeleteMorph methodsFor: 'layout' stamp: 'SR 4/17/2009 16:37'!
acceptDroppingMorph: aMorph event: evt 

	(aMorph isUserStoryMorph or: [aMorph isTaskMorph])
		ifTrue: [aMorph model delete. aMorph delete].
! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 17:05'!
acceptsTasks

	^ true! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'topa 3/11/2009 15:46'!
acceptsUserStories

	^ true! !

!XpfDeleteMorph methodsFor: 'initialization' stamp: 'topa 3/19/2009 14:38'!
initialize

	super initialize.
	self image: TrashCanMorph initializeTrashPic.! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model

	^ model! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model: anObject

	model := anObject.! !

!XpfDeleteMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:07'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph | aMorph isTaskMorph! !

ImageMorph subclass: #XpfUserStoryAddMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph commentStamp: 'topa 3/9/2009 15:16' prior: 0!
I am a Morph that should behave somehow like a Button, yet are embeddable into
a PasteUpMorph.!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mfp 4/28/2009 10:46'!
emptyUserStory

	^ Dictionary newFrom:	{'title' -> 'Please enter content for new user story'}! !

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mt 11/7/2009 11:45'!
emptyUserStoryAt: aPoint

	^ Dictionary newFrom: {
		'title' -> 'Please enter content for new user story'.
		'position' -> aPoint}.! !

!XpfUserStoryAddMorph class methodsFor: 'initialize-release' stamp: 'cs 3/11/2009 17:57'!
forProjects: anXpfProject

	^ self new model: anXpfProject! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:53'!
icon

	^ icon ifNil: [icon := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self iconContent readStream) ]! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:41'!
icon: anIcon

	icon := anIcon.! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:39'!
iconContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAFIAAAA2CAYAAABUSc7XAAAAGXRFWHRTb2Z0d2FyZQBBZG9i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'! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'topa 3/11/2009 14:00'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryAddMorph methodsFor: 'initialization' stamp: 'topa 4/20/2009 17:57'!
initialize

	super initialize.
	self
		image: self class icon.! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model

	^ model! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model: anObject

	model := anObject.! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
mouseDown: evt
	
	^ self performAction openInHand! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'mt 4/28/2009 19:20'!
performAction
	"for Button behavior"

	^ XpfUserStoryMorph forUserStory: XpfNewUserStory new! !

PanelMorph subclass: #XpfIterationSidebarMorph
	instanceVariableNames: 'model selectedTitles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:44'!
click: anXpfIteration with: anEvent from: anExpanderTitleMorph

	anEvent redButtonChanged ifTrue: [
		self selectIteration: anXpfIteration with: anEvent from: anExpanderTitleMorph.
		anEvent wasHandled: true].
	anEvent yellowButtonChanged ifTrue: [
		self openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph..
		anEvent wasHandled: true].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/12/2009 21:27'!
editIdealTime: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter ideal time:' title: 'XPF-Client' entryText: anXpfIteration timeIdeal).
	answer ifNotNil: [anXpfIteration timeIdeal: answer].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:43'!
editName: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter iteration name:' title: 'XPF-Client' entryText: anXpfIteration title).
	answer ifNotNil: [
		anXpfIteration title: answer.
		anExpanderTitleMorph titleText: anXpfIteration title].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'topa 1/2/2010 17:36'!
fill

	self model iterations do: [:iteration | |expander|
			expander := (UITheme current
				newExpanderIn: self
				label: (iteration title ifNil: [''])
				forAll: {XpfIterationTreeMorph for: iteration}).
			expander titleMorph on: #mouseUp send: #click:with:from: to: self withValue: iteration.
			self addMorph: expander.
			expander titleMorph addDependent: self.
			expander titleMorph labelMorph beAllFont: XpfFontProvider sansFont.
			iteration isXpfFutureIteration ifTrue: [expander titleMorph labelMorph: MenuIcons xpfOpenStories asMorph].

			iteration isXpfFutureIteration
				ifTrue: [self selectIteration: iteration with: nil from: expander titleMorph]].
	
	self submorphs size > 1 ifTrue: [ | expander tree |
		expander := self submorphs second expanded: true.
		tree := expander submorphs detect: [:m | m ~= expander titleMorph].
		self selectIteration: tree model iteration with: nil from: expander titleMorph].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:19'!
initialize

	super initialize.
	
	self
		selectedTitles: Set new;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 200@700.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 3/26/2009 12:47'!
model

	^ model! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 11:30'!
model: anXpfProject

	self model ifNotNil: [
		self model removeDependent: self.
		self model iterations removeDependent: self].
	model := anXpfProject.
	self model ifNotNil: [
		self model addDependent: self.
		self model iterations addDependent: self.
		self fill.].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/20/2009 10:35'!
openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph
	
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Iteration'.
	menu add: 'Edit name' target: self selector: #editName:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Edit ideal time' target: self selector: #editIdealTime:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Remove' target: self selector: #removeIteration:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu popUpInWorld.! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 11:52'!
removeAllIterations

	self
		changed: #iterationDeselectAll;
		removeAllMorphs;
		selectedTitles: Set new.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'mt 4/25/2009 14:59'!
removeIteration: anXpfIteration

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you sure?' title: 'Proceed') ifTrue: [
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'mt 4/25/2009 15:01'!
removeIteration: anXpfIteration with: anExpanderTitleMorph

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you sure?' title: 'Proceed') ifTrue: [
			(self selectedTitles includes: anExpanderTitleMorph) ifTrue: [
					self selectedTitles remove: anExpanderTitleMorph.
					self changed: #iterationDeselected with: anXpfIteration].
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 20:32'!
selectIteration: anXpfIteration with: evt from: anExpanderTitleMorph 

	(self selectedTitles includes: anExpanderTitleMorph)
		ifTrue: [
			self selectedTitles remove: anExpanderTitleMorph.
			self changed: #iterationDeselected with: anXpfIteration]
		ifFalse: [
			self selectedTitles add: anExpanderTitleMorph.
			self changed: #iterationSelected with: anXpfIteration].
	self updateHighlight.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:18'!
selectedTitles

	^ selectedTitles! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:17'!
selectedTitles: anObject

	selectedTitles := anObject! !

!XpfIterationSidebarMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 11:47'!
update: aSymbol

	super update: aSymbol.
	self updateHighlight.

	aSymbol = #iterations | aSymbol = #iterationsLoaded ifTrue: [
		self model iterations reloadDepth: 2.
		self			
			removeAllIterations;
			fill].! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 19:24'!
updateHighlight
	
	self submorphsDo: [:morph | 
		(morph isKindOf: ExpanderMorph) ifTrue: [
			morph titleMorph fillStyle:
				(UITheme current expanderTitleNormalFillStyleFor: morph titleMorph)]].

	self selectedTitles do: [:morph | morph fillStyle: (morph fillStyle mixed: 3/4 with: Color green)].! !

!Object methodsFor: '*xpf-client' stamp: 'topa 4/20/2009 17:19'!
isValueBarWrapper

	^ false! !

Object subclass: #XpfIterationTreeModel
	instanceVariableNames: 'iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mt 4/1/2009 11:36'!
iteration

	^ iteration! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mfp 4/29/2009 17:17'!
iteration: anXpfIteration

	self iteration ifNotNil: [self iteration userStories removeDependent: self].
	iteration := anXpfIteration.
	self iteration ifNotNil: [self iteration userStories addDependent: self].! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:49'!
rootItems

	| temp |
	temp :=  self iteration userStories collect: [:us | (XpfUserStoryItemWrapper with: nil model: us)].
	temp isEmpty
		ifTrue: [^ {ListItemWrapper with: ''}]
		ifFalse: [^ temp].! !

!XpfIterationTreeModel methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 17:15'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #userStoriesLoaded
		ifTrue: [self changed: #rootItems].! !

!ListItemWrapper methodsFor: '*Xpf-Client' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ false! !

ListItemWrapper subclass: #XpfEntityItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfEntityItemWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 13:14'!
with: anObject model: aModel

	| result |
	result := super with: anObject model: aModel.
	aModel addDependent: result.
	^ result! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mig 4/19/2009 22:30'!
asString

	^ (model title ifNil: ['(no title)']) asString truncateWithElipsisTo: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mig 4/19/2009 22:29'!
balloonText

	^ (model title ifNil: ['(no title)']) asString withNoLineLongerThan: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:50'!
contents

	^ {self createTimeEstimatedItem.
		self createTimeActualItem}! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 15:17'!
createTimeActualItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeActual;
		preferredColor: ((self model timeEstimated isNil | self model timeActual isNil)
			ifTrue: [Color black]
			ifFalse: [ | diff |
				((diff := self model timeEstimated - self model timeActual) abs < 2)
				ifTrue: [Color green muchDarker]
				ifFalse: [	diff > 0
					ifTrue: [Color orange]
					ifFalse: [Color red]]]);
		prefix: 'Actual Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:09'!
createTimeEstimatedItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeEstimated;
		preferredColor: (self model timeEstimated isNil
			ifNil: [Color black]
			ifNotNil: [Color blue]);
		prefix: 'Estimated Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:33'!
hasXpfModel

	^ true! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:29'!
update: aSymbol

	super update: aSymbol.
	self changed: #rootItems.! !

XpfEntityItemWrapper subclass: #XpfUserStoryItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:53'!
contents

	^ super contents asOrderedCollection
		add: self createTasksItem;
		yourself! !

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
createTasksItem

	^ XpfTaskListItemWrapper with: nil model: self model tasks! !

ListItemWrapper subclass: #XpfTaskListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:02'!
asString

	^ 'Tasks'! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
contents

	^ self model collect: [:task |
		XpfEntityItemWrapper with: nil model: task]! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ true! !

ListItemWrapper subclass: #XpfValueBarWrapper
	instanceVariableNames: 'getValueSelector preferredColor prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfValueBarWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:05'!
max

	^ 25! !

!XpfValueBarWrapper methodsFor: 'converting' stamp: 'mt 3/25/2009 17:11'!
asString

	| value |
	
	value := self model perform: self getValueSelector.
	
	value ifNil: [^ '(not set)'].
	^ (String new: ((10 * value) / self class max) ceiling) collect: [:e | $+]! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:33'!
balloonText

	^ '{1} {2}' format: {self prefix. self model perform: self getValueSelector}! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
getValueSelector

	^ getValueSelector! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
getValueSelector: anObject

	getValueSelector := anObject.! !

!XpfValueBarWrapper methodsFor: 'testing' stamp: 'topa 4/20/2009 17:18'!
isValueBarWrapper

	^ true! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:21'!
preferredColor

	^ preferredColor! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:22'!
preferredColor: anObject

	preferredColor := anObject.! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
prefix

	^ prefix! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
prefix: anObject

	prefix := anObject.! !

IndentingListItemMorph subclass: #XpfIndentingListItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIndentingListItemMorph methodsFor: 'as yet unclassified' stamp: 'topa 1/2/2010 17:36'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	| fontToUse |
	"We use our own font. Else, do the super doings, thus copied"
	fontToUse := anObject isValueBarWrapper
		ifTrue: [XpfFontProvider monoFont]
		ifFalse: [XpfFontProvider sansFontAt: 10].
	container := hostList.
	complexContents := anObject.
	self initWithContents: anObject asString font: fontToUse emphasis: nil.
	indentLevel := 0.
	isExpanded := false.
 	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [
		priorMorph nextSibling: self.
	].
	indentLevel := newLevel.
	icon := anObject icon.
	self extent: self minWidth @ self minHeight! !

!XpfIndentingListItemMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/18/2009 16:15'!
isFirstItem

	^ owner notNil and: [owner submorphs first == self]! !

StandardWindow subclass: #XpfClient
	instanceVariableNames: 'sidebar mainPanel userStoryPools historyPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:18'!
defaultHeight

	^ 480! !

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:19'!
defaultWidth

	^ 640! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:42'!
font: n at: size
	
	TTCFont registry isEmpty ifTrue: [TTCFont registerAll].
	^  TTCFont familyName: n pointSize: size emphasis: 0! !

!XpfClient class methodsFor: 'initialization' stamp: 'topa 5/18/2009 15:30'!
frameForCount: count index: index

	^ (LayoutFrame new)
		leftFraction: 0; 
		rightFraction: 1; 
		topFraction: (count - index ) * (1/count); 
		bottomFraction: (count - index) + 1 * (1/ count).
! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 17:22'!
monoFont

	^ self monoFontAt: 10! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:41'!
monoFontAt: aPointSize

	^ self font: 'BitstreamVeraSansMono' at: aPointSize! !

!XpfClient class methodsFor: 'user interface' stamp: 'cs 5/27/2009 11:14'!
open
	
	[^ self openProject: XpfLoginProcessor new project]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient class methodsFor: 'user interface' stamp: 'cs 6/12/2009 16:00'!
openProject: project
	
	| instance |
	[#(model open) do: [:step |
		World displayWorldSafely.
		step = #model ifTrue: [instance := self new model: project].
		step = #open ifTrue: [instance openInWorld]] displayingProgress: 'Opening client...'.

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 17:15'!
sansFont

	^ self sansFontAt: 11! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:42'!
sansFontAt: aPointSize

	^ self font: 'BitstreamVeraSans' at: aPointSize! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 15:13'!
buttonBar

	^ self newRow: {
		self createAddIterationButton.
		self createToggleHistoryButton.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 9/8/2009 16:42'!
createAddIterationButton

	^ IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfAddIteration;
		actionSelector: #createIteration;
		setBalloonText: 'Add new iteration'! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 15:15'!
createDeleteMorph
	
	^ XpfDeleteMorph new
		bottomLeft: 4@XpfClient defaultHeight + self topLeft;
		model: self model;
		yourself! !

!XpfClient methodsFor: 'initialization' stamp: 'mig 4/15/2009 14:07'!
createFeedbackButton

	| box |

	box := self createBox
		labelGraphic: MenuIcons xpf7LikeFeedback;
		actionSelector: #doFeedback;
		setBalloonText: 'give feedback to the developers'.
	
	"retain title bar height"
	box extent: box extent x @ self boxExtent y.

	labelArea addMorph: box behind: label.
! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 4/2/2009 11:17'!
createFirstIteration

	| result |
	result := self textEntry: 'No iteration found. Choose a name for the first iteration:' title: 'Add initial iteration'. 	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> (result ifNil: ['New Iteration'])})! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 4/2/2009 11:16'!
createIteration

	| result |
	result := self textEntry: 'Choose a name for the iteration:' title: 'Add iteration'. 
	
	result ifNil: [^ self].
	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> result})! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 4/17/2009 16:24'!
createToggleHistoryButton

	^ IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfHistory;
		actionSelector: #toggleHistory;
		setBalloonText: 'Toggle visibilty of history panel'! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 16:31'!
createUserStoryAddMorph
	
	^ XpfUserStoryAddMorph new
		topRight: XpfClient defaultWidth@5 + self topLeft;
		model: (self model iterations detect: [:iter | iter isXpfFutureIteration]);
		yourself! !

!XpfClient methodsFor: 'submorphs-add/remove' stamp: 'mig 4/3/2009 11:15'!
delete

	self model repository stopUpdating.
	super delete.
! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:26'!
deselectAllIterations

	self userStoryPools copy do: [:pool |
		self userStoryPools remove: pool.
		self mainPanel removeMorph: pool scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:26'!
deselectIteration: anXpfIteration

	| pool |
	pool := self userStoryPools detect: [:morph | morph model id = anXpfIteration id] ifNone: [nil].
	pool ifNotNil: [
		self userStoryPools remove: pool.
		self mainPanel removeMorph: pool scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'feedback' stamp: 'mig 4/15/2009 14:33'!
doFeedback

	| feedback |
	feedback := UIManager default
		multiLineRequest: 'Please enter your feedback:'
		centerAt: self center
		initialAnswer: ''
		answerHeight: Display height / 3.
		
	(feedback isNil or: [feedback isEmpty]) ifTrue: [^ self].
	
	(RestSocket postDocumentFromUrl: self feedbackUrl request: '' content: feedback) isOk
		ifTrue: [self message: 'Feedback was successfully sent to the server. Thank you!!' title: 'Feedback']
		ifFalse: [self abort: 'There was a problem sending the feedback to the server.' title: 'Feedback'].! !

!XpfClient methodsFor: 'feedback' stamp: 'SR 4/15/2009 14:30'!
feedbackUrl

	^ (self model baseUri, 'feedback/mail') asUrl! !

!XpfClient methodsFor: 'menu' stamp: 'mfp 4/29/2009 14:59'!
fullScreen

	super fullScreen.
	self bounds setOrigin: self bounds origin corner: ((self bounds origin x + 1200)@self bounds corner y).! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:16'!
historyPanel

	historyPanel ifNil:
		[historyPanel := (XpfHistoryMorph forProject: self model) client: self].
	^ historyPanel! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 5/18/2009 14:47'!
initialize

	super initialize.	
	self
		addMorph: ((self newDialogPanel listDirection: #leftToRight) layoutInset: 2; cellInset: 2)
			frame: (0@0 corner: 1@1);
		extent: self class defaultWidth @ self class defaultHeight;
		userStoryPools: OrderedCollection new;
		sidebar: XpfIterationSidebarMorph new;
		createFeedbackButton.! !

!XpfClient methodsFor: 'initialization' stamp: 'mfp 5/6/2009 11:20'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: (self newColumn: {
			(self newRow: {
				(self newColumn: {self userStoryButtons. self sidebar. self buttonBar}) hResizing: #shrinkWrap; cellInset: 1.
				self mainPanel}) vResizing: #spaceFill; cellInset: 0; yourself.
			self historyPanel}).! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:10'!
mainPanel
	
	mainPanel ifNil: [
		self mainPanel: ((self newColumn: {}) layoutInset: 1; cellInset: 4).
		self mainPanel changeProportionalLayout].
	^ mainPanel! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
mainPanel: anObject

	mainPanel := anObject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:10'!
model: anXpfProject

	super model: anXpfProject.
		
	self
		title: anXpfProject title;
		initializeUserInterface.

	(self sidebar)
		addDependent: self;
		model: self model.
	self model isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:31'!
selectIteration: anXpfIteration

	| pos newPool scrollPane |
	pos := self model iterations indexOf: anXpfIteration.
	newPool := XpfUserStoryPoolMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		model: anXpfIteration.
	anXpfIteration isXpfFutureIteration ifTrue: [newPool fillStyle: Color white].
	
	scrollPane := (newPool withScrollBars)
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		borderWidth: 0.


	self userStoryPools isEmpty
		ifTrue: [
			self userStoryPools add: newPool.
			self mainPanel addMorph: scrollPane]
		ifFalse: [
			self userStoryPools do: [:pool | 
				(self model iterations indexOf: pool model) > pos ifTrue: [
					self userStoryPools add: newPool before: pool.
					self mainPanel addMorph: scrollPane inFrontOf: pool scrollPane.
					^ self updateUserStoryPools]].
			self userStoryPools add: newPool.
			self mainPanel addMorphBack: scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/1/2009 13:53'!
sidebar

	^ sidebar! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
sidebar: anXpfIterationSidebarMorph

	sidebar := anXpfIterationSidebarMorph.! !

!XpfClient methodsFor: 'menu' stamp: 'cs 4/6/2009 17:47'!
toggleHistory

	self historyPanel
		visible: self historyPanel visible not;
		disableTableLayout: self historyPanel visible not.! !

!XpfClient methodsFor: 'updating' stamp: 'mt 4/28/2009 12:48'!
update: aSymbol
	
	aSymbol = #iterationDeselectAll ifTrue: [self deselectAllIterations].
	super update: aSymbol.! !

!XpfClient methodsFor: 'updating' stamp: 'mt 4/28/2009 12:49'!
update: aSymbol with: anObject
	
	aSymbol = #iterationSelected ifTrue: [self selectIteration: anObject].
	aSymbol = #iterationDeselected ifTrue: [self deselectIteration: anObject].
	
	super update: aSymbol with: anObject.! !

!XpfClient methodsFor: 'updating' stamp: 'topa 5/18/2009 15:27'!
updateUserStoryPools

	| uspCount |
	uspCount := self userStoryPools size.
	
	(uspCount > 0) ifTrue: [
		self userStoryPools withIndexDo: [:userStoryPool :index|
			userStoryPool withScrollBars layoutFrame:
				(self class frameForCount: uspCount index: index)].
		self mainPanel addPaneSplitters].! !

!XpfClient methodsFor: 'initialization' stamp: 'mfp 5/6/2009 11:25'!
userStoryButtons

	^ self newRow: {
		self newToolSpacer hResizing: #spaceFill.
		self createUserStoryAddMorph.
		self newToolSpacer hResizing: #spaceFill.
		self createDeleteMorph.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/27/2009 17:46'!
userStoryPools

	^ userStoryPools! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/27/2009 17:46'!
userStoryPools: anObject

	userStoryPools := anObject.! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/18/2009 09:44'!
addPolymorphColumn

	^ self addMorphBack: (self theme newColumnIn: self for: {})! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/18/2009 09:42'!
addPolymorphRow

	^ self addMorphBack: (self theme newRowIn: self for: {})! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/30/2009 13:43'!
newColumnFor: controls
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/30/2009 13:44'!
newRowFor: controls
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !
